#ifndef HELPER_MAP_AZ_H
#define HELPER_MAP_AZ_H

#include "gentrex.h"

/* Minimalistic map implementation that uses lowercase letters between
   'a' and 'z' to store nodes. */

typedef struct gentrex_map_az_s {
	gentrex_nodecomp_t map[26];
} gentrex_map_az_t;

/* initialize (reset) a map allocated by the user */
void gentrex_map_az_init(gentrex_map_az_t *user_ctx);

/* map hooks for gentrex API */
void gentrex_map_az_get(void *user_ctx, const char *name, gentrex_nodecomp_t *result);
void gentrex_map_az_set(void *user_ctx, const char *name, gentrex_nodecomp_t ndc);

/* helpers for the application for accessing the .straight nodes directly */
void *gentrex_map_az_get_node(void *user_ctx, const char *name);
void gentrex_map_az_set_node(void *user_ctx, const char *name, void *node);

#endif /* HELPER_MAP_AZ_H */
